/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: kernel_cfg.c 49 2012-09-06 04:41:53Z ertl-hiro $
 */

/*
 *  ͥɸإåե
 */
#include "kernel_impl.h"

/*
 *  ͥγƥإåե
 */
#include "task.h"
#include "semaphore.h"
#include "eventflag.h"
#include "dataqueue.h"
#include "pridataq.h"
#include "mailbox.h"
#include "mempfix.h"
#include "cyclic.h"
#include "alarm.h"
#include "interrupt.h"
#include "exception.h"
#include "time_event.h"

/*
 *  ͥ륳ե졼󵭽ҥإåե
 */
#include "kernel_cfg.h"

/*
 *  Ƥ뤿Υޥ
 */
#ifndef TOPPERS_EMPTY_LABEL
#define TOPPERS_EMPTY_LABEL(type, var)		type var[0]
#endif

/*
 *  ǽ
 */

const ID tmax_tskid = (TMIN_TSKID + TNUM_TSKID - 1);

#if TNUM_TSKID > 0

TINIB tinib_table[TNUM_TSKID];
TCB tcb_table[TNUM_TSKID];

#else /* TNUM_TSKID > 0 */

#error TNUM_TSKID must not be 0.

#endif /* TNUM_TSKID > 0 */

/*
 *  ޥեǽ
 */

const ID tmax_semid = (TMIN_SEMID + TNUM_SEMID - 1);

#if TNUM_SEMID > 0

SEMINIB seminib_table[TNUM_SEMID];
SEMCB semcb_table[TNUM_SEMID];

#else /* TNUM_SEMID > 0 */

TOPPERS_EMPTY_LABEL(SEMINIB, seminib_table);
TOPPERS_EMPTY_LABEL(SEMCB, semcb_table);

#endif /* TNUM_SEMID > 0 */

/*
 *  ٥ȥե饰ǽ
 */

const ID tmax_flgid = (TMIN_FLGID + TNUM_FLGID - 1);

#if TNUM_FLGID > 0

FLGINIB flginib_table[TNUM_FLGID];
FLGCB flgcb_table[TNUM_FLGID];

#else /* TNUM_FLGID > 0 */

TOPPERS_EMPTY_LABEL(FLGINIB, flginib_table);
TOPPERS_EMPTY_LABEL(FLGCB, flgcb_table);

#endif /* TNUM_FLGID > 0 */

/*
 *  ǡ塼ǽ
 */

const ID tmax_dtqid = (TMIN_DTQID + TNUM_DTQID - 1);

#if TNUM_DTQID > 0

DTQINIB dtqinib_table[TNUM_DTQID];
DTQCB dtqcb_table[TNUM_DTQID];

#else /* TNUM_DTQID > 0 */

TOPPERS_EMPTY_LABEL(DTQINIB, dtqinib_table);
TOPPERS_EMPTY_LABEL(DTQCB, dtqcb_table);

#endif /* TNUM_DTQID > 0 */

/*
 *  ͥ٥ǡ塼ǽ
 */

const ID tmax_pdqid = (TMIN_PDQID + TNUM_PDQID - 1);

#if TNUM_PDQID > 0

PDQINIB pdqinib_table[TNUM_PDQID];
PDQCB pdqcb_table[TNUM_PDQID];

#else /* TNUM_PDQID > 0 */

TOPPERS_EMPTY_LABEL(PDQINIB, pdqinib_table);
TOPPERS_EMPTY_LABEL(PDQCB, pdqcb_table);

#endif /* TNUM_PDQID > 0 */

/*
 *  ᡼ܥåǽ
 */

const ID tmax_mbxid = (TMIN_MBXID + TNUM_MBXID - 1);

#if TNUM_MBXID > 0

MBXINIB mbxinib_table[TNUM_MBXID];
MBXCB mbxcb_table[TNUM_MBXID];

#else /* TNUM_MBXID > 0 */

TOPPERS_EMPTY_LABEL(MBXINIB, mbxinib_table);
TOPPERS_EMPTY_LABEL(MBXCB, mbxcb_table);

#endif /* TNUM_MBXID > 0 */

/*
 *  Ĺס뵡ǽ
 */

const ID tmax_mpfid = (TMIN_MPFID + TNUM_MPFID - 1);

#if TNUM_MPFID > 0

MPFINIB mpfinib_table[TNUM_MPFID];
MPFCB mpfcb_table[TNUM_MPFID];

#else /* TNUM_MPFID > 0 */

TOPPERS_EMPTY_LABEL(MPFINIB, mpfinib_table);
TOPPERS_EMPTY_LABEL(MPFCB, mpfcb_table);

#endif /* TNUM_MPFID > 0 */

/*
 *  ϥɥ鵡ǽ
 */

const ID tmax_cycid = (TMIN_CYCID + TNUM_CYCID - 1);

#if TNUM_CYCID > 0

CYCINIB cycinib_table[TNUM_CYCID];
CYCCB cyccb_table[TNUM_CYCID];

#else /* TNUM_CYCID > 0 */

TOPPERS_EMPTY_LABEL(CYCINIB, cycinib_table);
TOPPERS_EMPTY_LABEL(CYCCB, cyccb_table);

#endif /* TNUM_CYCID > 0 */

/*
 *  顼ϥɥ鵡ǽ
 */

const ID tmax_almid = (TMIN_ALMID + TNUM_ALMID - 1);

#if TNUM_ALMID > 0

ALMINIB alminib_table[TNUM_ALMID];
ALMCB almcb_table[TNUM_ALMID];

#else /* TNUM_ALMID > 0 */

TOPPERS_EMPTY_LABEL(ALMINIB, alminib_table);
TOPPERS_EMPTY_LABEL(ALMCB, almcb_table);

#endif /* TNUM_ALMID > 0 */

/*
 *  ߴǽ
 */

const ID tmax_isrid = (TMIN_ISRID + TNUM_ISRID - 1);

#if TNUM_ISRID > 0

ISRINIB isrinib_table[TNUM_ISRID];
ISRCB isrcb_table[TNUM_ISRID];

#else /* TNUM_ISRID > 0 */

TOPPERS_EMPTY_LABEL(ISRINIB, isrinib_table);
TOPPERS_EMPTY_LABEL(ISRCB, isrcb_table);

#endif /* TNUM_ISRID > 0 */

/*
 *  󥿥ƥѥåΰ
 */

#ifdef ISTK

#define TOPPERS_ISTKSZ	ISTKSZ
#define TOPPERS_ISTK	ISTK

#else /* ISTK */
#ifdef ISTKSZ

static STK_T			istack[COUNT_STK_T(ISTKSZ)];
#define TOPPERS_ISTKSZ	ROUND_STK_T(ISTKSZ)
#define TOPPERS_ISTK	istack

#else /* ISTKSZ */
#ifdef DEFAULT_ISTK

#define TOPPERS_ISTKSZ	DEFAULT_ISTKSZ
#define TOPPERS_ISTK	DEFAULT_ISTK

#else /* DEAULT_ISTK */

static STK_T			istack[COUNT_STK_T(DEFAULT_ISTKSZ)];
#define TOPPERS_ISTKSZ	ROUND_STK_T(DEFAULT_ISTKSZ)
#define TOPPERS_ISTK	istack

#endif /* DEAULT_ISTK */
#endif /* ISTKSZ */
#endif /* ISTK */

const SIZE		istksz = TOPPERS_ISTKSZ;
STK_T *const	istk = TOPPERS_ISTK;

#ifdef TOPPERS_ISTKPT
STK_T *const	istkpt = TOPPERS_ISTKPT(TOPPERS_ISTK, TOPPERS_ISTKSZ);
#endif /* TOPPERS_ISTKPT */

/*
 *  Memory Area Allocated by Kernel
 */

#ifdef KMEM

#define TOPPERS_KMEMSZ	KMEMSZ
#define TOPPERS_KMEM	KMEM

#else /* KMEM */

static MB_T				memory[TOPPERS_COUNT_SZ(KMM_SIZE, sizeof(MB_T))];
#define TOPPERS_KMMSZ	TOPPERS_ROUND_SZ(KMM_SIZE, sizeof(MB_T))
#define TOPPERS_KMM		memory

#endif /* KMEM */

const SIZE		kmmsz = TOPPERS_KMMSZ;
MB_T *const		kmm = TOPPERS_KMM;

/*
 *  ।٥ȴ
 */

TMEVTN   tmevt_heap[TNUM_TSKID + TNUM_CYCID + TNUM_ALMID];

/*
 *  ƥ⥸塼ν
 */

void
initialize_object(void)
{
	initialize_task();
#if TNUM_SEMID > 0
	initialize_semaphore();
#endif /* TNUM_SEMID > 0 */
#if TNUM_FLGID > 0
	initialize_eventflag();
#endif /* TNUM_FLGID > 0 */
#if TNUM_DTQID > 0
	initialize_dataqueue();
#endif /* TNUM_DTQID > 0 */
#if TNUM_PDQID > 0
	initialize_pridataq();
#endif /* TNUM_PDQID > 0 */
#if TNUM_MBXID > 0
	initialize_mailbox();
#endif /* TNUM_MBXID > 0 */
#if TNUM_MPFID > 0
	initialize_mempfix();
#endif /* TNUM_MPFID > 0 */
#if TNUM_CYCID > 0
	initialize_cyclic();
#endif /* TNUM_CYCID > 0 */
#if TNUM_ALMID > 0
	initialize_alarm();
#endif /* TNUM_ALMID > 0 */
	initialize_interrupt();
#if TNUM_ISRID > 0
	initialize_isr();
#endif /* TNUM_ISRID > 0 */
	initialize_exception();
}
